--
-- Written by peinzser
--

-- Initialize the addon
local addonName, addon = ...
local hbd = LibStub("HereBeDragons-1.0")
addon = LibStub("AceAddon-3.0"):NewAddon(addon, addonName, "AceConsole-3.0", "AceEvent-3.0")

-- Extract version from TOC file
addon.version = GetAddOnMetadata(addonName, "Version")
addon.title = GetAddOnMetadata(addonName, "Title")
addon.author = GetAddOnMetadata(addonName, "Author")

-- Reference name
local Buzzbox = addon

-- Addon defaults
Buzzbox.defaults = {
  profile = {
    minimap = {
      hide = false
    },
    tfreq = 999,
    encryptionKey = "0",
    encryptionopt = false,
    sendernameopt = 1,
    senderRPnameopt = true,
    noiseopt = true,
    volume = 1,
    maxrange = 1500,
    devicename = "Buzzbox",
    micsens = 1,
    autoem = false,
  },
}

--  --------------------------
--      Sending a message
--  --------------------------

function Buzzbox:CHAT_MSG_SAY(event, message, sender_realm)
  if self:MicrophoneActive() then
    if self.id == nil then self.id = GetChannelName("xtensionxtooltip2") end -- Get channel's ID
      if self.rpname == nil then self.rpname = self:GetRPName() end -- if not done so already, get player's IC name
    local sender = self:RemoveServer(sender_realm) -- remove realm from name
    local px, py, instanceID = hbd:GetPlayerWorldPosition()

    if sender == self.pname or self.db.profile.micsens == 2 then -- Only run these commands if sender is yourself or you have "Everyone" set as mic sensitivity
      local nametosend = nil -- Initialize local variable

      if self.db.profile.micsens == 2 then -- If sensitivity is set to Everyone
        nametosend = sender
      else -- If sensitivity is set to self
        nametosend = self.rpname
      end

      local encKey = self:GetEncryptionKey()
      -- protocol
      SendChatMessage("BZBP3"..self.db.profile.tfreq.." "..encKey.." "..px.." "..py.." "..nametosend.." "..self.db.profile.maxrange, "CHANNEL", nil, self.id)
      SendChatMessage("BZB3"..self.db.profile.tfreq..""..instanceID.." "..message.."", "CHANNEL", nil, self.id);
    end
  end
end

function Buzzbox:CHAT_MSG_YELL(event, message, sender_realm)
  if self:MicrophoneActive() then
    if self.id == nil then self.id = GetChannelName("xtensionxtooltip2") end -- Get channel's ID
      if self.rpname == nil then self.rpname = self:GetRPName() end -- if not done so already, get player's IC name
    local sender = self:RemoveServer(sender_realm) -- remove realm from name
    local px, py, instanceID = hbd:GetPlayerWorldPosition()

    if sender == self.pname or self.db.profile.micsens == 2 then -- Only run these commands if sender is yourself or you have "Everyone" set as mic sensitivity
      local nametosend = nil -- Initialize local variable

      if self.db.profile.micsens == 2 then -- If sensitivity is set to Everyone
        nametosend = sender
      else -- If sensitivity is set to self
        nametosend = self.rpname
      end

      local encKey = self:GetEncryptionKey()
      message = string.upper(message)
      -- protocol
      SendChatMessage("BZBP3"..self.db.profile.tfreq.." "..encKey.." "..px.." "..py.." "..nametosend.." "..self.db.profile.maxrange, "CHANNEL", nil, self.id)
      SendChatMessage("BZB3"..self.db.profile.tfreq..""..instanceID.." "..message.."", "CHANNEL", nil, self.id);
    end
  end
end

--  ----------------------------
--      Receiving a message
--  ----------------------------

function Buzzbox:CHAT_MSG_CHANNEL(event, message, sender_realm)
  if self.status == 1 then
    local sender = self:RemoveServer(sender_realm) -- remove realm from name
    if sender ~= self.pname then
      firstWord, restOfString = message:match("(%w+)(.+)") -- seperate first word from the rest of the message
      local px, py, instanceID = hbd:GetPlayerWorldPosition(); -- get player's position
      local encKey = self:GetEncryptionKey() -- init max distance

      --  -------------------------------------------------------
      --    String containing encryption key, name and position
      --  -------------------------------------------------------

      if firstWord == "BZBP3"..self.db.profile.tfreq.."" then -- extract message data
        words, wordc = self:BreakStringIntoWords(restOfString)
        self.encryptionKeyReceived = words[1] -- encryption
        self.angle, self.distance = hbd:GetWorldVector(instanceID, px, py, tonumber(words[2]), tonumber(words[3]));
        self.senderRPname = self:GetSenderRPName(words,wordc) -- take the words remaining and combine them to make the IC name
        if(words[wordc]:match("%d")) then -- this is for compatibility with versions 1.4.0 and older
          self.maxdistance = tonumber(words[wordc]) -- get device's range
        else
          self.senderRPname = self.senderRPname.." "..words[wordc] -- message does not have range, last word is part of the name
        end
      end

      --  ----------------------------------------
      --    String containing the actual message
      --  ----------------------------------------

      if firstWord == "BZB3"..self.db.profile.tfreq..""..instanceID.."" and self.distance <= self.maxdistance and encKey == self.encryptionKeyReceived then
        if self.db.profile.noiseopt == true then
          restOfString = self:InsertCrackles(restOfString) -- insert noise in message
        end
        if self.senderRPname ~= nil and self.db.profile.senderRPnameopt == true then -- if sender has RP name and enabled it
          self:PrintMessage(restOfString, self.senderRPname) -- print the IC name
        else
          self:PrintMessage(restOfString, sender) -- print the OOC name
        end
        self.maxdistance = 1500;
      end
    end
  end
end
